//---------------------------------------------------------------------
//(16x16Dot)LED Game for AVR  by Takuya Matsubara / NICO Corp. 2006
// http://www.nico.to/avr/
//
//   BEEP
//
// pp͋֎~BĔzz͎Rɂł܂B
// Ĕzzꍇɂ͂킩₷`ŖLĂB
// ̕͏C֎~(Please do not delete a document from here.)
//---------------------------------------------------------------------
// 
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>

#ifndef F_CPU
	#define F_CPU 8000000	// CPUNbNg[Hz]
#endif

#define T2PRESCALE  256		// ^C}2vXP[l
#define T2PRESCALER 6		// ^C}2vXP[ݒ
	// 1=div1 / 2=div8 / 3=div32 / 4=div64 / 5=div128 / 6=div256 / 7=div1K

#define HZMAX ((F_CPU/T2PRESCALE)/2)		// TEho͉\ȍōg
#define HZMIN (((F_CPU/T2PRESCALE)/256)/2)	// TEho͉\ȍŒg

unsigned char beep_sta;
unsigned int beep_cnt;

#define BEEP_PORT PORTD
#define BEEP_DDR  DDRD
#define BEEP_BIT  0

//--------------------------------------------------------------------------
SIGNAL (SIG_OVERFLOW2)
{
    TCNT2 = beep_sta;        // ^C}2̏lݒ   

	BEEP_PORT ^= (1<<BEEP_BIT);

	if((BEEP_PORT & (1<<BEEP_BIT))==0){ // 1̏o͊
    	beep_cnt--;
	 	if(beep_cnt == 0){	//JE^0̏ꍇATEho͏I
    		TIMSK2 &= ~(1 << TOIE2);  // ^C}2I[o[t[荞݋֎~
		}
	}
}
//--------------------------------------------------------------------------
//TEh@\
// ETEh@\܂B^C}2gp܂B
//߂lFint^BĐ\ȍōgԂ܂BŒg͂̒l1/256łB
unsigned int beep_init(void)
{
    TCCR2A= 0;       // TCCR2 ^C}[hݒ
    TCCR2B= T2PRESCALER;       // TCCR2 vXP[ݒ 

	BEEP_DDR |= (1<<BEEP_BIT);	//|[go͂ɐݒ
	BEEP_PORT &= ~(1<<BEEP_BIT);	//|[gLowo

	return(HZMAX);
}


//---------------------------------------------------------------------------
//TEh̋It
//ETEho͂IɎ~߂܂B
void beep_off(void)
{
	TIMSK2 &= ~(1 << TOIE2);  // ^C}2I[o[t[荞݋֎~
	BEEP_PORT &= ~(1<<BEEP_BIT);	//|[gLowo
}

//---------------------------------------------------------------------------
//TEho̓JE^̎擾
//߂lFint^B0ȏゾƍĐƂӖłB
unsigned int beep_getcnt(void)
{
	return(beep_cnt);
}

//---------------------------------------------------------------------------
//TEhĐ
// hzFg[Hz]
// timeFĐ[100msP]BƂ10Ȃ1bԍĐ܂B
void beep_set(unsigned int hz,int time)
{
	if(hz < HZMIN) hz=HZMIN;
	if(hz > HZMAX) hz=HZMAX;

	beep_sta = (unsigned char)(0x100- (HZMAX/hz));
	beep_cnt = (hz/10)*time;

    TCNT2 = beep_sta;        // ^C}2̏lݒ   
    TIFR2 |= (1 << TOV2);    // I[o[t[tONA
    TIMSK2 |= (1 << TOIE2);  // ^C}2I[o[t[荞݋
}

