//---------------------------------------------------------------------
//(16x16Dot)LED Game for AVR  by Takuya Matsubara / NICO Corp. 2006-2007
// http://www.nico.to/avr/
//
// MISSILE
//E㉺Eňړ
//EA/BŃ~TC
//
// pp͋֎~BĔzz͎Rɂł܂B
// Ĕzzꍇɂ͂킩₷`ŖLĂB
// ̕͏C֎~(Please do not delete a document from here.)
//
//	2007.2.10	΂߈ړ\, GfBÔh~  Yuki
//---------------------------------------------------------------------
#include <avr/io.h>
#include <avr/interrupt.h>
#include "led.h"
#include "ledx.h"
#include "rand.h"
#include "sio.h"
#include "sw.h"
#include "beep.h" 
#include "sleeping.h" 


unsigned int *pVram;

#define EXP_MAX 11	//p^[MAX
#define SPSIZE 7	// chara size[pixel]

unsigned char pat_exp[EXP_MAX][SPSIZE] = {
	{
		0b0000000,	/* 0 */
		0b0000000,
		0b0000000,
		0b0001000,
		0b0000000,
		0b0000000,
		0b0000000
	},{
		0b0000000,	/* 1 */
		0b0000000,
		0b0001000,
		0b0011100,
		0b0001000,
		0b0000000,
		0b0000000
	},{
		0b0000000,	/* 2 */
		0b0000000,
		0b0011100,
		0b0011100,
		0b0011100,
		0b0000000,
		0b0000000
	},{
		0b0000000,	/* 3 */
		0b0001000,
		0b0011100,
		0b0111110,
		0b0011100,
		0b0001000,
		0b0000000
	},{
		0b0000000,	/* 4 */
		0b0011100,
		0b0111110,
		0b0111110,
		0b0111100,
		0b0011100,
		0b0000000
	},{
		0b0001000,	/* 5 */
		0b0011100,
		0b0111110,
		0b1111111,
		0b0111110,
		0b0011100,
		0b0001000
	},{
		0b0001000,	/* 6 */
		0b0011100,
		0b0111110,
		0b1111111,
		0b0111110,
		0b0011100,
		0b0001000
	},{
		0b0000000,	/* 7 */
		0b0011100,
		0b0111110,
		0b0111110,
		0b0111100,
		0b0011100,
		0b0000000
	},{
		0b0000000,	/* 8 */
		0b0001000,
		0b0011100,
		0b0111110,
		0b0011100,
		0b0001000,
		0b0000000
	},{
		0b0000000,	/* 9 */
		0b0000000,
		0b0011100,
		0b0011100,
		0b0011100,
		0b0000000,
		0b0000000
	},{
		0b0000000,	/* 10 */
		0b0000000,
		0b0001000,
		0b0011100,
		0b0001000,
		0b0000000,
		0b0000000
	}
};


void led_printd(int x);
void led_print(char *p);

//---------------------------------------------------------------------
void led_printd(int x)
{
	unsigned char temp;
	int ketaval=1000;

	while (ketaval != 0) {
		temp = x / ketaval;
		led_putch('0'+temp);
		x -= (ketaval*temp);
		ketaval /= 10;
	}
}

//---------------------------------------------------------------------
void led_print(char *p)
{
	while(*p != 0){
		led_putch(*p++);
	}
}

//---------------------------------------------------------------------
// LN^[\
// x:XW
// y:YW
// *dat:p^[Bchar^|C^
void led_spput(char x,char y, char *dat)
{
	char i;

	x-=3;
	y-=3;

	for(i=0;i<SPSIZE;i++){
		if(y>15)break;
		if(y>=0){
			if(x < 0)
				*(pVram+y  ) |= ((unsigned int)*dat << ((16-SPSIZE)-x)) ;
			else
				*(pVram+y  ) |= (((unsigned int)*dat << (16-SPSIZE)) >> x);

		}
		y++;
		dat++;
	}
}

//---------------------------------------------------------------------
// LN^[
// x:XW
// y:YW
//void led_spclr(char x,char y)
//{
//	char i;
//	if(x==-1)return;
//
//	for(i=0;i<SPSIZE;i++){
//		if(y<0)continue;
//		if(y>15)break;
//		*(pVram+y  ) &= ~((0xff << (16-SPSIZE)) >> x);
//		y++;
//	}
//}

void vram_claer(void)
{
	int i;

	for(i=0;i<15;i++){
		*(pVram+i) = 0;
	}
	*(pVram+15)=0xffff;
}


#define MISSMAX 8	// ~TCő吔Ã~TC2܂
#define ID_A 0
#define ID_B 1

typedef struct {
	char x1;	// o_ XW
	char y1;	// o_ YW
	char x2;	// e_ XW
	char y2;	// e_ YW
	char x;		// s XW
	char y;		// s YW
	char cnt;	// eJE^
	char exp;	// JE^
} ST_MISSILE;   // DOT\

ST_MISSILE miss[MISSMAX];

void missile_fire(int i,char x1,char y1,char x2,char y2)
{
	if(miss[i].x1==-1){
		if(i<=ID_B)
			beep_set(150 ,1);

		miss[i].x1 = x1;
		miss[i].y1 = y1;
		miss[i].x  = x1;
		miss[i].y  = y1;
		miss[i].x2 = x2;
		miss[i].y2 = y2;
		miss[i].cnt = 0;	//eJE^
		miss[i].exp = -1;	//JE^()
	}
}

char led_point(char x,char y)
{
	if(	*(pVram+y) & (0x8000 >> x))
		return(1);
	else
		return(0);
}


//---------------------------------------------------------------------
// C
int main(void)
{
	#define SX 8
	#define SY 15
	#define HITMAX 20	//e܂ł̍őJE^
	#define SWCHKCNT 250   // XCb`o[v
	#define SPEED_FAST 7  //őXs[h
	#define SPEED_SLOW 17 //łxXs[h

	int i;
	char x,y;
	char endflag;
	int imax;
	int tx,ty;
	int score;
	char speed;	//~TC̑x
	int keycnt;

	sw_init(SW_ALL);
	rand_init();
	beep_init();
	sio_init();
	led_init();				// LED
	pVram = led_getvram();

	sei();
	while(1){
		keycnt = 0;

		led_init();
		beep_set(500,7);

		vram_claer();	//nʈȊO
		led_locate(0,0);
		led_print("MISSILE");

		for(i=0;i<10000;i++){
			led_disp();		// LEDʍXV
		}

		endflag=0;
		score = 0;
		speed = SPEED_SLOW;
		imax = 4;
		x = 8;
		y = 8;
		for(i=0; i<MISSMAX; i++){
			miss[i].x1 = -1;
			miss[i].exp = -1;
		}

		while(endflag==0){
			led_disp();		// LEDʍXV

			keycnt++;
			if(keycnt < SWCHKCNT) continue;
			keycnt = 0;

			//---------
			if(sw_get(SW_RIGHT)) {	// RXCb`
				if(x < 14) x++;
			}else if(sw_get(SW_LEFT)) {	// LXCb`
				if(x > 1) x--;
			}
			// ΂߈ړł悤ɉ by Yuki
			if(sw_get(SW_UP)) {		// UXCb`
				if(y > 1) y--;
			}else if(sw_get(SW_DOWN)) {	// DXCb`
				if(y < 11) y++;
			}

			if(sw_get(SW_A)) {		// AXCb`
				missile_fire( ID_A,  2, 14, x, y);	//eA
			}else if(sw_get(SW_B)) {		// BXCb`
				missile_fire( ID_B, 14, 14, x, y);	//eB
			}

			vram_claer();	//nʈȊOS

			for(i=0; i<MISSMAX; i++){	// ̕`
				if(miss[i].exp != -1){ //
					led_spput(
						miss[i].x,miss[i].y, &pat_exp[(int)miss[i].exp][0]
					);
					beep_set(150 + miss[i].exp*25 ,1);

					miss[i].exp++;	//JE^
					if(miss[i].exp >= EXP_MAX){//̊
						miss[i].x1 = -1;	//
						miss[i].exp = -1;	//JE^
						if(i > ID_B){
							score++;
							if((score & 0b11)==0){
								if(imax < (MISSMAX-2))imax++;
								if(speed > SPEED_FAST)speed--;
							}
							if(miss[i].y > 14)
								endflag=1; //Q[I[o[
						}
					}
				}
			}

			for(i=0; i<MISSMAX; i++){
				if(miss[i].x1 == -1)continue; //݂
				if(miss[i].exp != -1)continue; //̏ꍇ

				//Oisj
				if(i <= ID_B){
					miss[i].cnt++;
				}else{
					if(rand_get(speed) < 1)
						miss[i].cnt++;
				}
				tx = miss[i].x2 - miss[i].x1;
				ty = miss[i].y2 - miss[i].y1;
				tx = tx * miss[i].cnt / HITMAX;
				ty = ty * miss[i].cnt / HITMAX;
				tx += miss[i].x1;
				ty += miss[i].y1;
				miss[i].x = (char)tx;
				miss[i].y = (char)ty;
				if((led_point(tx,ty)!=0)||(miss[i].cnt >= HITMAX)){
					// oiUjA͒e
					miss[i].exp = 0; //Jn
				}
			}
			for(i=0; i<MISSMAX; i++){
				if(miss[i].x1 == -1)continue;
				led_pset(miss[i].x, miss[i].y, 1);
			}
			i=rand_get(imax)+2;
			missile_fire( i, rand_get(16), 0, rand_get(16), 15);

			led_line(x-1,y  ,x+1,y  ,2);
			led_line(x  ,y-1,x  ,y+1,2);
		}

		// ȉ̕ړ by Yuki
		vram_claer();	//nʈȊO
		led_locate(0,1);
		led_printd(score);//XRA

		for(ty=0; ty<10; ty++){
			// VRAMAhX擾 by Yuki
			unsigned int	*vram;
			vram = led_getvram();

			x = rand_get(14)+1;
			y = rand_get(4)+12;
			for(tx=0; tx < EXP_MAX ;tx++){
				// ȉ̕̕Ɉړ
				//vram_claer();	//nʈȊO
				//led_locate(0,1);
				//led_printd(score);//XRA

				// XRẢnʂ̏܂ł by Yuki
				unsigned char	i;
				for (i = 7; i < 15; i++){
					vram[i] = 0;
				}

				led_spput( x, y, &pat_exp[tx][0] );
				beep_set(150 + tx*25 ,1);

				for(i=0;i<150;i++){
					led_disp();		// LEDʍXV
				}
			}
		}
		sleeping();
	}
}


